/* 
 gestione di thereminoSDR (frequenza & livello segnale)
 tramite bridge SeriHAl V2.11 e slot Theremino memory mapped
 
 routine di parsing dei dati in arrivo copiata da
 http://www.cplusplus.com/reference/cstring/strtok/
 
 Theremino serial:
  Com = arduino - speed 57600
  trasmit slot on serial ON
  only on demand ON
  slot write 20 - xx al slot read  30 - xx
  Theremino sdr:
  i/o first slot= 20 (20=frequenza  30 = signal)
 ----
 arduino
 - pin2,3 encoder
 - pin 4,5,6,7,8,9 display LCD
 - pin 11 pulsante
 - pin 13 led 
 - pin 10,12 free
 
   all'avvio pigiare il bottone dopo la connessione di serihal
   ruotando l'encoder si varia la frequenza di sintonizzazione
   pigiando il pulsante si aggiorna la lettura del livello di segnale
 */
 
#include <LiquidCrystal.h> 
#include <rotary.h> // adeguare il codice alla libreria usata
#define build "> ardu-SDR 100 <"
#define N 10             // numero slot ricevuti
const float f_start= 93900.0;  // Khz iniziali
const float f_step=100.0;      // KHz step
byte P2=2;
byte P3=3;
byte led=13;
byte but=11;
float slot[11];          // vettore dei dati per slot
char str[127] ;          // vettore caratteri ricevuti
char inChar;             // singolo carattere ricevuto 
float SDRlevel,SDRfreq;
int i,j,kk,kk1;         // contatori
LiquidCrystal lcd(9, 8, 7, 6, 5, 4);
Rotary r = Rotary(2,3);   // pin 2,3 encoder
volatile int stato;       // ritorno encoder
//-----------------------
void encoder() {       // routinr di interrupt encoder
 unsigned char result = r.process();         // 16 DIR_CW 32 DIR_CWW
 if (result){ stato=((result*2)-48)/(-16);}  // +1 CW -1 CWW
 } 
//-----------------------

void setup() {                          
 pinMode (led,OUTPUT);
 pinMode (but, INPUT_PULLUP);
 attachInterrupt(digitalPinToInterrupt(P2), encoder, CHANGE);
 attachInterrupt(digitalPinToInterrupt(P3), encoder, CHANGE);
 Serial.begin (57600);
 i=1;                     // inzializza posizione vettore ricezione
 lcd.begin(16, 2); 
 lcd.setCursor(0, 0);  lcd.print(build);        // display  versione
 lcd.setCursor(0, 1);  lcd.print("****************");
 delay(2000);  
 
 while(digitalRead(but)){   // attende la connessione di seriaHAL
  lcd.setCursor(0, 0);  lcd.print("CONNECT SERIHAL"); 
  lcd.setCursor(0, 1);  lcd.print("  PUSH BUTTON  ");       
  digitalWrite(led,!digitalRead(led));
  delay(200);
  digitalWrite(led,LOW);
  }
  
 SDRfreq=f_start;                         
 // scrive 1°slot seriHAl (frequenza) e riceve 10 slot
 Serial.print(SDRfreq,0); Serial.println(); 
 } 
//--------------

void loop() {
  if (!digitalRead(but))  {single_read(); }  // lettura manuale
  if(Serial.available())  {leggi_slot();}    // dati ricevuti
  if(stato)  {scrivi_slot(); }               // encoder ruotato
  // fai altro
} 
//-------------------

void leggi_slot(){                   // riceve i 10 slot
while (Serial.available() > 0) {     // dati presenti
  inChar = Serial.read();            // legge carattere
 
 if (inChar != '\n') {               // attesa terminatore
   str[i] =inChar;
   i=i+1;
   }
  
 else {                       // parsing 
  char * pch;                 
  pch = strtok (str,";");     //elenco delimitatori parsing <;>
  j=1;
  while (pch != NULL)  {
   slot[j]=atof(pch);         // converte stringa in float
   j=j+1;
   pch = strtok (NULL, ";"); 
   }
        
  SDRlevel=slot[1];          // 1° slot rx configurato in seriHal
  lcd.setCursor(0, 0);  lcd.print("freq:           ");
  lcd.setCursor(6, 0);  lcd.print(SDRfreq,3);    // display frequenza
  lcd.setCursor(0, 1);  lcd.print("level:          ");
  lcd.setCursor(7, 1);  lcd.print(SDRlevel,0);    // display livello
 
  i=0;                     // svuota vettore lettura e vettore slot
  for (int k=0;k<50;k++){str[k]="";}
  for (int k=0;k<=N;k++){slot[k]=0;}
  }  // close else
 }   // close while 
}    //close function
//----------------

void scrivi_slot(){
 if(stato==1)  SDRfreq+=f_step;   // CW  incrementa frequenza
 if(stato==-1) SDRfreq-=f_step;   // CWW decrementa frequenza
 stato=0;                         // azzera stato encoder
 Serial.print(SDRfreq,0);   Serial.println();                
 }
//---------------

void single_read(){
 Serial.print(SDRfreq,0); Serial.println(); 
 delay(200);
 }
//----------------
